.area _DATA
.area _CODE

.include "cpctelera.h.s"
.include "person.h.s"
.include "hero.h.s"

;;Sprites
.globl _person_hater	;;RED 	-> 0
.globl _person_lover	;;GREEN -> 1

;;Person data
random_x: 		 	 .db #1
random_y: 		 	 .db #1
num_haters: 		 .db #1
num_lovers:			 .db #1

;;0 person_active	0 -> no	|	1 -> yes
;;1 person_x		
;;2 person_y
;;3 person_w
;;4 person_h
;;5 person_colisioned	0 -> no	|	1 -> yes
;;6 person_sprite		0 -> red|	1 -> green
;;7 person_turn			0 -> no	| 	1 -> yes	
;;8 nada	

people_table:
	 ;;	 a	 x	  y		w	h	 c    s	   t	nada
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #00, #00, #00, #06, #12, #00, #00, #00, #00
	.db #00, #00, #00, #06, #12, #00, #00, #01, #01
	.db #0xFF


;;==================================================================================
;; Extern call for update the Person
;;==================================================================================
people_update::
	ld ix, #people_table				;;Cargo tabla de personas	
	personsUpdateLopp:					;;Recorre todos las personas y las actualiza
		ld a, (ix)						;;A = person_active
		;;Fin personas		
		cp #0xFF						;;Si no quedan personas finaliza
			ret z
		;;Si no está activada todavía pasa a la siguiente
		cp #1						
		jp z, nexPersonUpdate				;;if (person_active == 0) -> nexPersonUpdate
			ld bc, #9						;;\BC = 9
			add ix, bc						;; |IX + BC -> IX + 9
			jr personsUpdateLopp			;;/Siguiente persona
		nexPersonUpdate:		
			;ld a, 7(ix)					;;| A = person_turn
			;cp #0						;;|
			;jr z, cambiar_turno			;;\if (person_turn = 1) -> cambiar_turno
				ld a, #0						;;|
				ld 7(ix), a						;;\ Cambio turno de la persona a: no actualizar en la siguiente
				
				;;Control de movimiento
				call person_move				;;Move the person randomly	
				
				;;Dibujado
				call person_draw				;;Draw a new_person

				;;Control de colisiones
				call hero_checkCollision		;;Check collisions between hero and person
				call person_checkCollision		;;Check collisions between person and person
				
				;;Siguiente persona
				ld bc, #9						;;\
				add ix, bc						;; |Siguiente persona 
				jr personsUpdateLopp			;;/
			;cambiar_turno:
			;	ld a, #1						;;|
			;	ld 7(ix), a						;;\ Cambio turno de la persona a: actualizar en la siguiente

			;	ld bc, #9						;;\
			;	add ix, bc						;; |Siguiente persona 
			;	jr personsUpdateLopp			;;/
	ret	
;;==================================================================================
;; Extern call for draw the Person
;;==================================================================================
people_draw::
	ld ix, #people_table				;;Cargo la tabla de personas
	personsDrawLopp:					;;Recorre todos las personas y las dibuja
		ld a, (ix)						;;A = person_active
		;;Fin personas		
		cp #0xFF						;;Si no quedan finaliza
			ret z
		;;Si no está activada todavía pasa a la siguiente
		cp #1						
		jp z, nexPersonDraw				;;if (person_active == 0) -> nexPersonDraw
			ld bc, #9						;;\
			add ix, bc						;; |Siguiente persona 
			jr personsDrawLopp				;;/
		nexPersonDraw:
			ld a, #0xFF						;;PALETTE color
			call person_draw				;;Draw a new_person
			ld bc, #9						;;\BC = 9
			add ix, bc						;; |HL + BC 
			jr personsDrawLopp				;;/Siguiente persona
	ret	
;;==================================================================================
;; Extern call for erase person who have collided
;; Desactive people who have collied
;;==================================================================================
people_eraseCollisions::
	ld ix, #people_table				;;Cargo la tabla de personas
	eraseCollisionLoop:					;;Recorre todos las personas y las dibuja
		ld a, (ix)						;;A = person_active
		;;Fin personas		
		cp #0xFF						;;Si no quedan finaliza
			ret z
		;;Si no está activada todavía pasa a la siguiente
		ld a, 0(ix)
		cp #1					
		jp z, nextCollision					;;if (person_collied == 0) -> nextCollision
			ld bc, #9						;;\
			add ix, bc						;; |Siguiente persona 
			jr eraseCollisionLoop			;;/
		nextCollision:
			ld a, 5(ix)						;;|
			cp #0							;;\Compruebo si ha colisionado
			jr z, noCollied					;; if (colision = 0) -> noCollied
			call person_erase				;;Erase the person
			ld bc, #9						;;\
			add ix, bc						;; |Siguiente persona 
			jr eraseCollisionLoop			;;/

		noCollied:
			ld bc, #9						;;\
			add ix, bc						;; |Siguiente persona 
			jr eraseCollisionLoop			;;/
	ret	

;;==================================================================================
;;Get everyone_died 
;; RETURN  A ->   1=yes , 0=no
;;==================================================================================
people_died::
	ld a, (num_haters)		;;|
	ld b, a					;;\Obtengo el numero de haters

	ld a, (num_lovers) 		;;Obtengo el numero de lovers
	
	add b					;;Obtengo la suma
	cp #0
	jr z, todosMuertos		;;Si la suma es 0 -> todos muertos
		ld a, #0
	ret
	todosMuertos:
		ld a, #1
	ret
;;==================================================================================
;;	Draw the Person
;;	DESTROYS: AF, BC, DE, HL
;; INPUT IX -> pointer to a person
;;==================================================================================
person_draw:
	;;Calculate Screen position
	ld de, #0xC0F0				;;Calculate Screen position
	ld c, 1(ix)					;;C=person_x
	ld b, 2(ix)					;;B=person_y
	call cpct_getScreenPtr_asm	;;HL = Pointer to screen

	ex de, hl
	ld c, 3(ix)				;;C = person_w
	ld b, 4(ix)				;;B = persons_h
	
	ld a, 6(ix)				;;A = person_sprite
	cp #0					;;if (person_sprite == 0) -> lover
	jr nz, lover
		ld	hl, #_person_hater
		call cpct_drawSprite_asm
	ret
	lover: 
		ld	hl, #_person_lover
		call cpct_drawSprite_asm
	ret
;;==================================================================================
;Move the person randomly arround
;all the map
;;==================================================================================
person_move:
	call cpct_getRandom_xsp40_u8_asm
    ld a, l
	cp #0
	jp nz, incrementar			;;if (random == 0) -> incrementar  //Para evitar matar personas
		inc a
	incrementar:
    cp #64
    jp c, primerRangoa
    cp #128
    jp c, segundoRangoa
    cp #192
    jp c, tercerRangoa
    ;; cuartoRango -> Subir
        ld a, 2(ix)				;;A = person_y
        cp #0		
            ret z
        cp #1
        	ret z
		sub a, #2
        ld 2(ix), a				;;person_y = A
    ret

    primerRangoa:				;; -> Derecha
        ld a, 1(ix)				;;person_x = A	
        cp #80-5				
        	ret z
        inc a
        ld 1(ix), a
    ret

    segundoRangoa:				;; -> Izquierda
        ld a, 1(ix)				;;A = person_x
        cp #0					;;No puede llegar a 0 o muere					
        	ret z
        dec a	
        ld 1(ix), a
    ret

    tercerRangoa:				;; -> Bajar
        ld a, 2(ix)				;; person_y
        cp #200-40
        	ret z
		cp #200-39
        	ret z
        add a, #2
        ld 2(ix), a
	ret
;;==================================================================================
;;Erase a person using IX
;;		INPUT IX pointer to a person
;;==================================================================================
person_erase::
	;;Desactive person
	ld 0(ix), #0				;;person_active = 0

	;; Calculate Screen position
	ld de, #0xC0F0				;;Video memory
	ld a,  1(ix)				;;|
	ld c, a						;;\ C=person_x
	ld a,  2(ix)				;;|
	ld b, a						;;\ B=person_y
	call cpct_getScreenPtr_asm	;;Get pointer to screen
	ex de, hl
	ld a, #0x00					;;PALETTE Black
	ld bc, #0x0C06				;;12x12
	call cpct_drawSolidBox_asm
	ret
;;==================================================================================
;;Get a random position X into (random_x)
;;==================================================================================
getRandomPosition:
	call cpct_getRandom_xsp40_u8_asm		;;Random generator
	ld a, l									;;A = random
		cp #0
		jp nz, correcto
			inc a							;;A++
		correcto:
			cp #72
			jp nc, posicionErronea
				ld (random_x), a			
			ret
			posicionErronea:
				call getRandomPosition
	ret
;;==================================================================================
;;Create a new lover
;;==================================================================================
person_create_lover::
	call getRandomPosition			;;C = randomPositionX
	ld hl, #people_table			;;Cargo tabla de personas	
	personsCreateLoverLopp:			;;Recorre todos las personas 
	ld a, (hl)						;;A = person_active
	;;Fin personas		
	cp #0xFF						;;Si no quedan finaliza
		ret z	
	;;Si no está activa la crea
	cp #1
	jp z, nextLoverCreate	
		ld a, #1					;;|hl = 0
		ld (hl), a					;;\person_active = 1 -> yes
		
		inc hl						;;|hl = 1
		ld a, (random_x)			;;|
		ld (hl), a					;;\person_x = random
		
		inc hl						;;|hl = 2
		ld a, (random_x)			;;|
		ld (hl), a					;;\person_y = random
		
		inc hl 						;;person_w	 |	hl = 3
		inc hl 						;;person_h	 | 	hl = 4
		
		inc hl						;;|	hl = 5
		ld a, #0					;;|				
		ld (hl), a					;;\ person_colisioned = 0 -> no

		inc hl						;;| hl = 6
		ld a, #1					;;|
		ld (hl), a					;;\	person_sprite = 1 -> green

		inc hl						;;|hl = 7
		ld a, #0					;;|
		ld (hl), a 					;;\person_turn = 0	-> no

		inc hl						;;hl = 0
	ret
	
	nextLoverCreate:
		ld bc, #9					;;\BC = 9
		add hl, bc					;; |	HL = HL + 9
		jp personsCreateLoverLopp	;;/Siguiente persona
	ret
;;==================================================================================
;;Create a new hater
;;==================================================================================
person_create_hater::
	call getRandomPosition			;;C = randomPositionX
	ld hl, #people_table			;;Cargo tabla de personas	
	personsCreateHaterLopp:				;;Recorre todos las personas 
	ld a, (hl)						;;A = person_active
	;;Fin personas		
	cp #0xFF						;;Si no quedan finaliza
		ret z	
	;;Si no está activa la crea
	cp #1
	jp z, nextHaterCreate	
		ld a, #1					;;|hl = 0
		ld (hl), a					;;\person_active = 1 -> yes
		
		inc hl						;;|hl = 1
		ld a, (random_x)			;;|
		ld (hl), a					;;\person_x = random
		
		inc hl						;;|hl = 2
		ld a, (random_x)			;;|
		ld (hl), a					;;\person_y = random
		
		inc hl 						;;person_w	 |	hl = 3
		inc hl 						;;person_h	 | 	hl = 4
		
		inc hl						;;|	hl = 5
		ld a, #0					;;|				
		ld (hl), a					;;\ person_colisioned = 0 -> no

		inc hl						;;| hl = 6
		ld a, #0					;;|
		ld (hl), a					;;\	person_sprite = 1 -> red

		inc hl						;;person_next |	  hl = 7
	ret
	
	nextHaterCreate:
		ld bc, #9					;;\BC = 9
		add hl, bc					;; |	HL = HL + 9
		jp personsCreateHaterLopp		;;/Siguiente persona
	ret
;;==================================================================================
;;Check all the possible collisions
;;	INPUTS IX = Pointer to a person 
;;	Recorre toda la tabla de posibles colisiones
;;==================================================================================
person_checkCollision:
	push ix								;;|
	pop hl								;;\Obtengo un puntero a la posición de la tabla del que colisiona
	
	ld bc, #9							;;|
	add hl, bc							;;\ Paso al siguiente
	
	peopleCollisionLopp:				;;|Recorre todos las personas y las comprueba
		ld a, (hl)						;;|A = nex_person
		cp #0xFF						;;|
			ret z						;;\Compruebo que es una persona
		cp #1							;;				
		jp z, comprobarColision		;;if (person == 0) -> nexPersonCollison
			ld bc, #9					;;\
			add hl, bc					;; |Siguiente persona
			jr peopleCollisionLopp		;;/
		comprobarColision:
			call checkCollision 		;;Check collisions between person and person
			ld bc, #9					;;\
			add hl, bc					;; | Siguiente persona
			jr peopleCollisionLopp		;;/
	ret	
;;==================================================================================
;;	Check Colision between person and person
;;	DESTROYS: AF, BC, DE, HL
;;	INPUTS: HL Pointer to person   IX: Pointer to person
;;	Compara con 
;;==================================================================================
checkCollision:
	;;colisionador =  IX
	;;colisionado = HL 

	;;Check horizontal colisions (En el ejeX)	
	;;Izquierda
	;; if (hero_x + hero_w < person_x) no_collision  -> hero_x + hero_w - person_x <= 0
	ld	a, 1(ix)					;;A = hero_x
	ld  c, a						;;C = hero_x				
	ld  a, 3(ix)					;;A = hero_w
	add c							;;A + C = hero_w + hero_x
	ld c, a							;;C = A
	inc hl							;;|hl = 1
	ld a, (hl) 						;;\A = person_x
	ld b, a							;;B = person_x
	ld a, c							;;A = hero_w + hero_x
	sub b							;;IX = person_x -> (hero_w + hero_x) - person_x
	jr z, no_collision				;;if ( (person_w + person_x) - person_x) == 0 ->no_colision
	jp m, no_collision				;;if ( (person_w + person_x) - person_x) < 0  ->no_colision
	
	;;Derecha
	;; if (person_x + person_w <= hero_x) ->  person_x + person_w - hero_x <= 0)
	ld a, (hl)						;;A = hero_x
	ld c, a							;;C = hero_x
	inc hl							;;hl = 2
	inc hl							;;hl = 3
	ld a, (hl)						;;A = hero_w
	add	c							;;A = hero_x + hero_w
	ld	c, a						;;C = hero_x + hero_w
	ld 	a, 1(ix)					;;A = person_x
	ld	b, a						;;B = person_x
	ld	a, c						;;A = (hero_x + hero_w)
	sub b							;;A - B -> (hero_x + hero_w) - person_x
	jr z, no_collision				;;if ( (person_w + person_x) - person_x) == 0 ->no_colision
	jp m, no_collision				;;if ( (person_w + person_x) - person_x) < 0  ->no_colision
	
 	;;Check vertical colisions
	;;Arriba
	;; if (hero_y + hero_h < person_y) no_collision -> obs_x + obs_w - hero_x <= 0
	ld	a, 2(ix)					;;A = hero_y
	ld  c, a						;;C = hero_y
	ld  a, 4(ix)					;;A = hero_h
	add c							;;A + C -> hero_y + hero_h
	ld c, a							;;C = hero_y + hero_h
	dec hl							;;hl = 2
	ld a, (hl)						;;A = person_y
	ld b, a							;;B = person_y
	ld a, c							;;A = hero_y + hero_h
	sub b 							;;A = hero_y + hero_h) - person_y
	jr z, no_collision				;;if ( (person_w + person_x) - person_x) == 0 ->no_colision
	jp m, no_collision				;;if ( (person_w + person_x) - person_x) < 0  ->no_colision

	;;Abajo
	;; if (person_y + person_h <= hero_y) -> hero_x + hero_w - obs_x <= 0)
	ld a, (hl)					;;A = person_y
	ld c, a						;;C = person_y
	inc hl						;;hl = 3
	inc hl						;;hl = 4
	ld a, (hl)					;;A = person_h
	add c						;;A = person_y + person_h 
	ld	c, a					;;C = person_y + person_h 
	ld 	a, 2(ix)	  			;;A = person_y
	ld	b, a					;;B = person_y
	ld	a, c					;;A = person_y + person_h
	sub b						;;A = (person_y + person_h) - person_y
	jr z, no_collision			;;if ( (person_w + person_x) - person_x) == 0 ->no_colision
	jp m, no_collision			;;if ( (person_w + person_x) - person_x) < 0  ->no_colision

	;;Compruebo el grupo de los colisionadores
	inc hl						;;|hl = 5
	inc hl						;;|hl = 6 
	ld a, (hl)					;;\Obtengo colisionado_group
	ld b, a						;;B = colisionado_group
	ld a, 6(ix)					;;|
	cp b						;;|
	jr z, no_collision			;;\Compruebo que no son iguales

	;;Reestart HL
	dec hl						;;hl = 5
	dec hl 						;;hl = 4
	dec hl						;;hl = 3
	dec hl						;;hl = 2
	dec hl						;;hl = 1
	dec hl 						;;hl = 0

	;;Collision
	ld 5(ix), #1
	ret

	;;No Collision
	no_collision:
	ret
;;==================================================================================
;;Kill everyone
;;	Update the table whit all people_active = 0
;;==================================================================================
people_kill_everyone::
	ld ix, #people_table					;;Cargo tabla de personas
	killLoop:							;;Recorre todos las personas y las actualiza
		ld a, (ix)						;;A = person
		;;Fin personas		
		cp #0xFF						;;Si no quedan finaliza
			ret z
		;;No existe todavía				;;Si no está inicactivada pasa a la siguiente
		cp #1						
		jp z, nextPersonKill			;;if (person == 0) -> nextPersonKill
			ld bc, #9					;;\BC = 9
			add ix, bc					;; |IX + BC -> IX + 9
			jr killLoop					;;/Siguiente persona
		nextPersonKill:
			ld 0(ix), #0					;;person_active = 0 -> no
			ld bc, #9						;;\BC = 9
			add ix, bc						;; |IX + BC 
			jr killLoop						;;/Siguiente persona
	ret	

;;==================================================================================
;;Count num haters
;;==================================================================================
countHaters:
	ld ix, #people_table				;;Cargo tabla de personas
	
	ld a, #0							;;|
	ld (num_haters), a					;;\ Clear actual value

	getHatersLoop:						;;Recorre todos las personas y las actualiza
		ld a, (ix)						;;A = person
		;;Fin personas		
		cp #0xFF						;;Si no quedan finaliza
			ret z
										;;Si no está activada pasa a la siguiente
		cp #1						
		jp z, nextHater					;;if (person == 0) -> nextHater
			ld bc, #9					;;\BC = 9
			add ix, bc					;; |IX + BC -> IX + 9 
			jr getHatersLoop			;;/Siguiente persona
		nextHater:
			ld a, 6(ix)					;;A = person_sprite
			cp #0
			jr z, unHaterMas			;;if (person_sprite == 0) -> unHaterMas
				ld bc, #9						;;\BC = 10
				add ix, bc						;; |IX + BC 
				jr getHatersLoop				;;/Siguiente persona
			unHaterMas:
				ld a, (num_haters)		;;|
				inc a					;;|
				ld (num_haters), a		;;\Incremento el numero de haters

				ld bc, #9						;;\BC = 10
				add ix, bc						;; |IX + BC 
				jr getHatersLoop				;;/Siguiente persona
	ret	

;;==================================================================================
;;Count num haters
;; RETURN B = num_haters
;;==================================================================================
getNumHaters::
	call countHaters	;;Obtengo num_haters
	ld a, (num_haters)	;;A = num_haters
	ld b, a				;;B = num_haters
	ret

;;==================================================================================
;;Count num lovers
;;==================================================================================
countLovers:
	ld ix, #people_table					;;Cargo tabla de personas
	ld a, #0
	ld (num_lovers), a

	getLoversLoop:						;;Recorre todos las personas y las actualiza
		ld a, (ix)						;;A = person
		;;Fin personas		
		cp #0xFF						;;Si no quedan finaliza
			ret z
										;;Si no está activada pasa a la siguiente
		cp #1						
		jp z, nextLover				;;if (person == 0) -> nextLover
			ld bc, #9					;;\BC = 9
			add ix, bc					;; |IX + BC -> IX + 9
			jr getLoversLoop			;;/Siguiente persona
		nextLover:
			ld a, 6(ix)					;;A = person_sprite
			cp #1	
			jr z, unLoverMas			;;if (person_sprite == 1) -> unLoverMas
				ld bc, #9						;;\BC = 6
				add ix, bc						;; |IX + BC 
				jr getLoversLoop				;;/Siguiente persona
				
			unLoverMas:
				ld a, (num_lovers)		;;|
				inc a					;;|
				ld (num_lovers), a		;;\Actualizo el numero de lovers

				ld bc, #9						;;\BC = 9
				add ix, bc						;; |IX + BC 
				jr getLoversLoop				;;/Siguiente persona
	ret	

;;==================================================================================
;;Count num lovers
;; RETURN B = num_lovers
;;==================================================================================
getNumLovers::
	call countLovers	;;Obtengo num_lovers
	ld a, (num_lovers)	;;A =  num_lovers
	ld b, a				;;B =  num_lovers
	ret